////////////////////////////////////////////////////////////////////////////////
// Coherent noise terrain generation interface. Makes use of NoiseLib
// Written by Vladeta Stojanovic (0602920@live.abertay.ac.uk).
//
// Version: 220311
////////////////////////////////////////////////////////////////////////////////

#ifndef _COHERENTNOISE_H_
#define _COHERENTNOISE_H_

#include "DefMethod.h"
#include "noiseutils.h"
using namespace noise;

class CoherentNoiseTerrain : public DefMethod
{
public:

	//Class constructor
	CoherentNoiseTerrain(int size);

	//Class destructor
	~CoherentNoiseTerrain();

	//Class generator methods
	void MultiFractalPerlin(double octaves, double baseFrequency, double frequency, double persistance, double lowerX, double upperX, double lowerZ , double upperZ); //simple perlin noise generated terrain

	inline int ReturnSize() {return miSize;}

	inline void ResetSize(int size) { miSize = size;}

	//Overloaed genrator
	void Generate();

	float mfField[262144];

private:
	int								miSize;
	int								randSeed;
	module::RidgedMulti				mountainTerrain;
	module::Billow					baseFlatTerrain;
	module::ScaleBias				flatTerrain;
	module::Perlin					terrainType;
	module::Select					finalTerrain;
	utils::NoiseMap					heightMap;
	utils::NoiseMapBuilderPlane		heightMapBuilder;

	//debug only
	utils::RendererImage			renderer;
	utils::Image					image;
};

extern CoherentNoiseTerrain gCoherentNoiseTerrain;
extern CoherentNoiseTerrain gChunkNoise;

#endif