///////////////////////////////////////////
// Frustum culling interface.
//
// Version: 170112_01
///////////////////////////////////////////

#ifndef _FRUSTUM_H_
#define _FRUSTUM_H_

#include <GL/glew.h>
#include <GL/freeglut.h>
#include <math.h>

class Frustum
{
public:

	Frustum();
	~Frustum();

	void ExtractFrustum();
	bool CheckCubeFrustum(float x, float y, float z, float size);


private:
	float mFrustum[6][4]; //view frustum
	float mProj[16]; //projection matrix
	float mModel[16]; //model matrix
	float mClip[16]; //clipping matrix
	float t;
};

extern Frustum gFrustum;
extern Frustum gChunkFrustum;

#endif